Subject: P1394> unsolicited status

From: Fumio Nagasaka <[email-masked]>
Date: Wed, 20 May 1998 13:34:37 +0900 (JST)

Dear Eric,

Today we had a productive result from 1394 PWG.
To support 1394 PWG profile, reverse directional data transfer (a printer send
data to a PC) does not require unsolicited status as a trigger to ask the
initiator to place input ORB for data sent from the printer.

The unsolicited status is an important portion of SBP-2 specification, I agree
with you. However to support this feature, a SBP-2 driver is required to have
several API functions to allow client software to use this functionality.

SetFSL_unsoicited_status_Enable(&fsl, true,...)
SetFSL_universalProcPtr_for_unsolicited_status(&fsl, ProcPtr,...)

If an Operating System don't like to open APIs of a SBP-2 driver, due to some
unknown reason, and if these is a filter driver over the SBP-2 driver to
generalize it as a usual read/write function driver,....
then any software developer who is writing a client software for this drivers
stack can not use this SBP-2 specific functionality.

Thus one of simple solution is to design transport protocol which does not
need unsolicited status.

Fumio Nagasaka wrote:
》Hi Eric,
》
》Thanks for your comment.
》
》I think this unsolicited status problem is not a problem of SBP-2 driver layer.
》
》In Macintosh OS, a PDEF code resource of a higher level printer driver usually
》uses PBWrite(&pb, Async) and PBRead(&pb, Async).
》
》In Windows OS, a SPOOLER user mode application usually uses WriteFile()
》and ReadFile().
》
》As PBRead() or ReadFile() is higher level interface, naturally these APIs are
》abstracted from a specific device level driver. In Mac OS8, a Printer Expert or
》PDEFs shall be abstracted from the FSL. Also in Windows, a SPOOLER
》shall be abstracted from the SBP-2 Class Driver. Usually these input functions
》are associated with input queues for normal reverse data path from peripherals.
》
》However unsolicited status seems unexpected input, thus higher level driver
》does not queued any input parameter block in the input queue, in this case.
》An OS is required to have SBP-2 specific input queue to cover unsolicited
》status, which is not required for USB, IrDA or MacSerial I/F.
》
》So even in Macintosh OS, if we need to make a Printer Expert which is not
》SBP-2 specific, and is applicable for other I/F, this layer shall have some
》notification method to ping a client driver when unsolicited status has come.
》And this notification does not work when this Printer Expert is connected to
》USB Expert or other device drivers. Is it neat? I think no.
》
》One possible solution is to develop a SBP-2 specific filter layer driver which
》invoke notification when unsolicited status has reported from SBP-2 layer.
》However then can this layer insert input data into input queue which was
》provided by higher level driver? I think it cannot.
》--------------------------------------------
》-------------------------------
》Fumio Nagasaka
》Epson Software Development Laboratory Inc.
》Tel +81 268 25 4111,  Fax +81 268 25 4627
》E-mail to [email-masked]
》
》-----Original Message-----
》From:	Eric Anderson [SMTP:[email-masked]]
》Sent:	Monday, May 18, 1998 2:16 PM
》To:	[email-masked]
》Subject:	RE: P1394> Agenda Items - Presentations etc.
》
》In my opinion, if an OS does not support unsolicited status, then
》that OS does not support SBP-2.  I cannot imagine that a consumer
》OS would not have full SBP-2 support.  I suggest that you should
》ask the OS vendor to support unsolicited status, or to explain how
》it can be used.
》
》Mac OS will have full support for unsolicited status in SBP-2.
》
》--------------------------------------
》Eric Anderson            [email-masked]
》Apple Computer, Inc.      408-974-8187
》--------------------------------------
》
》>Hi Greg,
》>
》>Please add short review for SBP-2 printing under current OS in the
》>agenda.
》>
》>Some consumer OS do not support unsolicited status, thus we need to
》>discuss whether we shall define reverse direction without unsolicited
》>status
》>or not. Also please see my PDF file attached previous e-mail,
》>
》>Thank you,
》>--------------------------------------------
》>-------------------------------
》>Fumio Nagasaka
》>Epson Software Development Laboratory Inc.
》>Tel +81 268 25 4111,  Fax +81 268 25 4627
》>E-mail to [email-masked]
》>
》>	-----Original Message-----
》>	From:	Gregory A. LeClair [SMTP:[email-masked]]
》>	Sent:	Friday, May 15, 1998 6:59 AM
》>	To:	'1394 PWG'
》>	Subject:	P1394> Agenda Items - Presentations etc.
》>
》>	Pardon my lateness.
》>
》>	If anyone has specific agenda ideas, needs, etc. please let me
》>know.
》>	I'm putting together the agenda for WASH / VA meeting now.
》>
》>	My rough idea follows:
》>
》>	Thanks,
》>	Greg LeClair
》>	[email-masked]
》>
》>	================
》>	Rough Ideas
》>
》>	Discussion items
》>	 - Monterey PWG mtg.
》>	 - PWG-C / PWG mtg.
》>	 - p1212r colocation for Monterey mtg.
》>
》>	 - p1212r activities - Greg / Others?
》>	 - ip/1394 activities 
》>	 - Rev 0.3 profile issues - Alan?
》>		- Dynamic LUNs - Alan
》>		- Config ROM - Greg
》>		- SBP-2 Model Issues - Alan
》>	 - Profile Publication
》>		- Need RAC assigned number
》>	 - Schedule next meeting / telecon
》
》

-------------------------------
Fumio Nagasaka
Epson Software Development Laboratory Inc.
Tel +81 268 25 4111,  Fax +81 268 25 4627
E-mail to [email-masked]